{

   The P-NAV Propeller Project
   Version 1.13
   R/C Autopilot with OSD and Ground Station Data Output via XBee 2-way Radio
     
    earl@uphi.net
    04/23/2009
    
    Contibutions by:
    
    Chris Anderson
    Jordi
    Paul Huber
    and thank you many other helpers on one way or another.....

                 <<<<<<<<<<<<<<<<<<<<< Prop Pin Outs >>>>>>>>>>>>>>>>>>>>

Free Pins     0,1,2,3,4,15,30,31  May be used for servos or ESC moter control                          

Used Pins for interfacing various things to Prop

5  Compass EN
6  Compass CLK
7  Compass DIN/DOUT (both)
8  GPS Rx   @ 57500 baud
9  GPS Tx
10 Ping in/out pin
11 RC Rx Ch. 5  AP on/off pin (gear switch)
12,13,14 Composit Tv output
15 LM1881 Sync Chip composit sync from chip used for video overlay     (not finished as of 4/23/09)
16 XBee Tx
17 XBee Rx
18,19,20,21 RC Servo outputs - Aleron , Throttle, Rudder, Elevator
22  6DOF Rx
23  6DOF Tx
24,25,26,27  RC Rx Channels 1,2,3,4  - Aleron , Throttle, Rudder, Elevator    
28,29 I2C pins to Barometer and Acclerometer Units

                                                      
}
CON
  
' NAME        PIN#  / VALUE
' ----------- ------- ----------  

  _CLKMODE            = XTAL1 + PLL16X
  _XINFREQ            = 5_000_000

' GPS Assignments                                        
  GPSin     = 08                          ' from GPS NEMA data @ 57600 baud
  GPSout    = 09
                                          ' to GPS (to set baud, SIRF or NMEA etc. May be needed for your GPS)
  Nunchuck_Addr = $A4                     ' Cheap accelorometer
  
' XBee Assignments                                        
  XBin      = 16                          ' from XBee  @ 57600 baud
  XBSout    = 17                          ' to XBee


' Video Output Assignments                              
  TVBase    = 12                                        ' TV base pin         

' RC Rx Input Assignments                              
  RxAler    = 24 'pin 4 on rx  aleron
  RxElev    = 25 'pin 5 on rx  elevator
  RxRudder  = 26 'pin 6 on rx  throtle                                                              
  RxThrot   = 27 'pin 7 on rx  rudder
  RxGear    = 11 'pin 11 on gear switch
  
' Servos Output pins
  SrvAle    = 20                                       
  SrvRudder = 21                                       
  SrvElev   = 18                                       
  SrvThrot  = 19
                               
  PING_Pin  = 10     'for close ground mesurement  
                     
    cEnable = 5      'clock,data,enable pins compass
    cClock  = 6
    cData   = 7 
 
                                                                                                          
VAR
  byte buffer [16]
  byte RxDOF
  byte cptr
  long   stackRC[100]                                    ' Sets up a stack space for Radio Control Receiver [increase if more servos]
  long  stackOSD[130]                                   ' Sets up a stack space for Radio Control Receiver [increase if more servos]
  long  stackGPS[200]
  long  stackDOF[200]
  word  rx[8],data[8]                                   ' FROM r/c receiver from ~0450 to ~1100   

   word rx5
   word rx6
   word rx7
   word rx8

   long _220uS
   byte i2cSCL, i2cSDA

   long rangeIN
   long rangeMM
   long rangeCM
   byte degree,rssi 
   word z,y,x
   long latitude,longitude,altitude
   byte temp

  word tempF,tempc,BaroP,tempfraw,temp1,temp2
  word UT,UP,p,B3,B4,B6,Y1,f1,f2,f3,f4,ac1,ac2,ac3,ac4,ac5,ac6,b1,b2
  word x1,x1a,x2,y2,x3,y3,x4,y4,b5,t,mmHg,mmIn,mmInF,mmInW
  word altitudeM,altitudeF
  word RunningCount,ax,ay,az,gx,gy,gz

   
OBJ                                                    
  clock      :  "Clock"                                 ' overall timers 
  tv         :  "tv_text"                               ' TV video output driver
  BS2        :  "BS2_Functions"                         ' BS2 Functions for I/O
  gps        :  "GPS_IO_mini_PNAV"                      ' Services GPS input and etrex extension           
  ser        :  "FullDuplexSerial_mini"
  Nun        :  "i2c_Accl_Data_Read"                    'N-chuck accl data subs
  i2cObject1 :  "ECi2c"                                 'i2c comm stuff
  ping       :  "ping"
  HM55B      :  "Sensor.HM55B.Compass"
  Baro       :  "EC_i2c_readbaro"
  xb         :  "XBee_Object"
  uart       :  "FullDuplexSerialPlus"
  uartDOF    :  "FullDuplexSerialPlusDOF"
  DOF2       :  "6dofbinary"
PUB start

''Initialize all necessary routines into their cogs as appropriate
   XB.start(17,16,0,115200)      ' XBee Comms - RX,TX, Mode, Baud
   XB.AT_Init                    ' Initialize for fast AT command use - 5 second delay to perform
   uartDOF.start (22,23,0,115200)     ' start uart on pins 22,23 for 6DOF Atomic board
 
Clock.Init(_XINFREQ)             ' set up clock for accurate 10/second
Clock.SetClock(_CLKMODE)         ' video update rate
Clock.MarkSync

cognew(RC_io,@stackRC)           ' start R/C in/out on its own cog
cognew(OSD_INI_Screen,@stackOSD)

tv.start(TVBase)                      ' start TV display
BS2.Start(30,31)
gps.start(GPSin,GPSout)               ' start GPS ingest (gets its own cog)
'Nun.init(28,29)                       ' scl and sda on pin 28 and pin 29 for I2C
HM55B.start(cEnable,cClock,cData)     ' start compass module
Baro.init(28,29)                      ' scl and sda on pin 28 and pin 29
tv.str(string($A,7,$B,1,$C,33))       ' set TV to line 1 col 33 white on red                            

  DIRA[20]~~                          'make servo pin output
  DIRA[21]~~                          'make servo pin output
  DIRA[18]~~                          'make servo pin output
  DIRA[19]~~                          'make servo pin output
  
degree := 0                           'initial heading

OSD_INI_Screen                        ' Print AutoPilot data Layout Screen
OSD_INI_Screen                        ' Havent figgured out why I need to do this twice ???                
XB.AT_init                            ' inish the xbee module
    waitcnt(25000000 + cnt)        
ControlLoop                           ' overall control loop

'***************************************************************************************
'                               Main program
'***************************************************************************************
                        
PUB ControlLoop                   ' primary loop
repeat

     GetAlt                        'Get the Barometric altitude
     degree := HM55B.degrees       ' Get compass heading from HM55B
     rangeIN := ping.Inches(PING_Pin)' Get Range In Inches
     rssi := XB.RxRSSI             ' 8 bit value
     OSD_GPS1                      ' Print all data on TV      
                            
     waitcnt(2500 + cnt)           ' wait a short time
     
     tv.str(string($A,38,$B,8))    'testing to flash arrow indicating XBee Data Xfer                 
     tv.str(string(4))                
     waitcnt(2500000 + cnt)           
     tv.str(string($A,38,$B,8))                     
     tv.str(string(5))

 
 
 
       
' At this point we have all HM55B Compass,GPS,accl x-y-z,RX,Distance to Ground (in Inches)
' and output servo position data !
' We can use the data for stabilization ,return home,send data to Gnd via XB or goto via gps !
'*********************************************************************************************
                                            
                          'Do everything over and over !
                          
'*********************************************************************************************

Pub OSD_INI_Screen        'Set Inishall OSD Screen


    tv.out($0)
  
'                  0         1         2         3        
'                  0123456789012345678901234567890123456789

    tv.str(string("___________ AutoPilot Data ____________",13))    'setup the tv screen graphics layout
    tv.str(string("Lock:  x      Compass      InHg        ",13))
    tv.str(string("Latitude:     _xxxx.xx    #Sat         ",13))
    tv.str(string("Longitude:    xxxxx.xx    GpsA         ",13))
    tv.str(string("Spd:          B-Alt       Head: xxx    ",13))
    tv.str(string("AutoPilot-    Ground(in Inches)        ",13))
    tv.str(string("    Pitch                 B-TempF      ",13))
    tv.str(string("    Roll                  Turning Left ",13))
    tv.str(string("    Yaw                   XB RSSI      ",13))
    tv.str(string("    Throt                 GND Link OK  ",13))
    tv.str(string("6DOF                              ",13))

'                  0         1         2         3        
'                  0123456789012345678901234567890123456789


Pub OSD_GPS1                  'On Screen Display Updater

'                             *** Print GPS Valid (A - X - V) ***
                                     
   tv.str(string($A,7,$B,1))    ' set to line 1 col 7                                  
   tv.str(gps.valid)

'                             *** Print Compass direction ***   (0 - 360)

                                            
  tv.str(string($A,22,$B,1))       ' set to line 1 col 22    
  tv.str(string("     "))
  tv.str(string($A,22,$B,1))
  tv.dec(degree)                   
   
'                             ***  Print Inches of Mercury ***  (21.00 - 29.99)

  tv.str(string($A,26,$B,1))        ' set to line 1 col 26
  tv.str(string("InHg "))
  tv.dec(mmInW)                     ' Print Whole In of Hg
  tv.str(string(". ",8))
  tv.dec(mmInF)                     ' Print Fraction of Hg

'                             ***  Print Latitude ***

  tv.str(string($A,15,$B,2))        ' set to line 2 col 15
  tv.dec(latitude)

'                             ***  Print N or S ***

  tv.str(string($A,24,$B,2))        ' set to line 2 col 26                        
  tv.str(gps.N_S)

'                             ***  Print Number of saellites in view ***

  tv.str(string($A,34,$B,2))        ' set to line 2 col 34                        
  tv.str(gps.satellites)

  tv.str(string($A,14,$B,3))                                
     tv.dec(longitude)

   tv.str(string($A,34,$B,6))
   tv.dec(tempF)                       'Temp from Baro

                                   
   tv.str(string($A,24,$B,3))                                
    tv.str(gps.E_W)
      tv.str(string($A,33,$B,3))
   tv.dec(altitude)                     'change to feet ******************************
   tv.str(string($A,7,$B,4))                                
    tv.str(gps.speed)
   tv.str(string($A,20,$B,4))                                
 tv.str(string("     "))
  tv.str(string($A,20,$B,4))                                
altitudeM := 1000*altitudeF / 3280      ' Actully 3.280839895 but who's counting !
    tv.dec(altitudeF)

       tv.str(string($A,32,$B,4))                                
    tv.str(gps.heading)

       tv.str(string($A,34,$B,8))       ' XBee RX Signal Strength <<<<<<<<< NOT working yet !
    tv.dec(xb.RXrssi)
 
  tv.str(string($A,10,$B,5))            ' Indication for AutoPilot on/off status
    if (rx[7] > 600)
      tv.str(string("On "))
    else
     tv.str(string("Off"))
     
       
tv.str(string($A,32,$B,5))
 tv.str(string("       "))
tv.str(string($A,32,$B,5))
  tv.dec(rangeIN)                        ' Print Distance in Inches from ground

    tv.str(string(13))
    tv.dec(rx[ 2])                'print Throttle input                      
    tv.str(string(13))
    tv.dec(rx[ 1])                'print Elevator input                     
    tv.str(string(13))
    tv.dec(rx[ 3])                'print Aleiron input                   
    tv.str(string(13))
    tv.dec(rx[ 4])                'print Rudder input

Get6DOF                           'get the 6dof data to be printed

      tv.str(string($A,5,$B,10)) 'set tv position to col 16 line 10
      tv.str(string("                    "))        'Print the decimal # for acceleration X axis        

      tv.str(string($A,5,$B,10)) 'set tv position to col 16 line 10
           
      tv.dec(ax)                  
      tv.str(string("X "))        'Print the decimal # for acceleration X axis        
      tv.dec(ay)              
      tv.str(string("Y "))        'Print the decimal # for acceleration Y axis   
      tv.dec(az)                 
      tv.str(string("Z Gyro-x")) 'Print the decimal # for acceleration Z axis
      tv.dec(gx)                 
      tv.str(string(" y"))              'Print the decimal # for acceleration X axis        
      tv.dec(gy)                       
      tv.str(string(" z"))              'Print the decimal # for acceleration X axis        
      tv.dec(gz)                       


' <<<<<<<<<<<<<<<<<<<<<<<<<<<<< Send data to ground station via XBee module >>>>>>>>>>>>>>>>>>>>>>

latitude := (uart.StrToDec(gps.latitude))     'Convert string to a number for Ground Station
longitude := (uart.StrToDec(gps.longitude))   'Convert string to a number for Ground Station   
altitude :=  (((uart.StrToDec(gps.altitude)/10) * 328)/100)   'Convert GPS meters string to desimal feet

xb.str(string(10,13,"!!!LAT:")) ' Ground Station START of Sentance and GPS latitude
xb.dec(latitude)
    
xb.str(string(",LON:"))         ' GPSlongitude
xb.dec(longitude)

xb.str(string(",SPD:"))         ' GPS Ground Speed
xb.str(gps.speed)

xb.str(string("CRT:"))          ' Rate of Climb
xb.dec(1)

xb.str(string(",ALT:"))         ' Takeoff Altitude
xb.dec(altitudeF)

xb.str(string(",ALH:"))         ' Altitude Above Ground
xb.dec(mmhg/4)
                               
xb.str(string(",CRS:"))         ' Course Berring
xb.dec(45)

xb.str(string(",BER:"))         ' Compass Reading (HM55B)
xb.dec(degree)

xb.str(string(",WPN:"))         ' Current Waypoint
xb.dec(6)

xb.str(string(",DST:"))         'Distance to Waypoint
xb.dec(9)  
xb.str(string(",***"))          ' Ground Station END of Sentance 

xb.str(string(10,13,"+++ASP:")) 'Ground Station start of sentance and GPS Ground Speed
xb.str(gps.speed)

xb.str(string(",RLL:"))         ' Roll gyro
xb.dec(Nun.accelY)

xb.str(string(",PCH:"))         ' Pitch gyro
xb.dec(Nun.accelx)
     
xb.str(string(",***"))          ' Ground Station END of Sentance   

'uart.stop
PUB RC_IO
repeat
                                        ' Get Radio Inputs
   rx[ 1] := BS2.PULSIN( RxAler,1)      ' aleron      
   rx[ 2] := BS2.PULSIN( RxElev,1)      ' elevator
   rx[ 3] := BS2.PULSIN( RxThrot,1)     ' throttle            
   rx[ 4] := BS2.PULSIN( RxRudder,1)    ' rudder          

    rx[ 7] := BS2.PULSIN( RxGear,1)     ' Gear input switch >550 = down(AP ON) 965 = up(AP OFF)

                                 'Servo output stuff

 '   BS2.PULSOUT(SrvAle,rx[ 2] )        'output to servos
 '   BS2.PULSOUT(SrvRudder,rx[ 1] )
 '   BS2.PULSOUT(SrvElev,Nun.accelY )   'this is for testing
 '   BS2.PULSOUT(SrvThrot, Nun.accelX ) 'this is for testing
 '   BS2.PULSOUT(SrvThrot, rx[ 3])

PUB GetAlt

Baro.init(28,29)                                        ' scl and sda on pin 28 and pin 29

           Baro.start_adcPres                            ' start the adc then
           Baro.readBaro                                 ' read data via i2c bus
           UP :=  baro.baro_f6 * 256 + baro.baro_f7      'raw 16 bit pressure data put in UP

     
                                     'Calibration Data
       F1 := 39535 '((baro.baro_f8 * 256) + baro.baro_f9)        'F1 my module data 
       F2 := 40600 '((baro.baro_fa * 256) + baro.baro_fb)        'F2 my module data
       F3 := 3707  '((baro.baro_fc * 256) + baro.baro_fd)        'F3 my module data
       F4 := 26866 '((baro.baro_fe * 256) + baro.baro_ff)        'F4 my module data

       AC1 := 6767        ' calculated values from MY module (only needed to do once)
       AC2 := 634         ' see data sheet for SMD500 on how to calkulate !
       AC3 := 152
       AC4 := 3707
       AC5 := 7
       AC6 := 2290
      
       B1 := ((AC3 - 1984) * (-17268)) / 2048 - 8970
       B2 := ((AC2 - 457) * B1 / 8) / (AC3 - 1984)



      X1 := UT  - (AC6 + 1415) * 8                          'X1 =  4310
      X2 := X1 * X1 / 8192                                  'X2 =  2267
      Y2 := -4955 * X2 / 8192                               'Y2 = -1372
      X3 := X2 * X1 / 65536                                 'X3 =  149
      Y3 := 11611 * X3 / 4096                               'Y3 =  422
      X4 := X2 * X2 / 65536                                 'X4 =  78
      Y4 := -12166 * X4 / 16384                             'Y4 =  -58
      B5 := (AC5 + 4096)* (2 * X1 + Y2 + Y3 + Y4)/ 1024     'B5 =  4237
      T  := (B5 + 8) / 8                                    'T =   265  T is degrees C times 10

      TempC := T /100
      TempF := TempC *  (9/5) + 32   
         
           '      calculate coefficients B3 and B4
       B6 := B5 - 4000                                    ' B6 = 237
       X1 := (B2 * (B6 * B6 / 4096 )) / 1024              ' X1 = 0
       X2 := (AC2 - 457) * B6 / 512                       ' X2 = -103
       X3 := ((X1 + X2) + 2) / 2                          ' X3 = -26
       B3 := (AC1 - 2218) * 2 + X3                        ' B3 = 11704
       Y1 := (AC3 -1984) * B6 / 1024                      ' Y1 = -415
       Y2 := (B1 * (B6 * B6 / 4096 )) / 65535             ' Y2 = 1
       Y3 := ((Y1 + Y2) + 2) / 2                          ' Y3 = -103
       B4 := (AC4 + 8808) * (Y3 + 32768) / 16384          ' B4 = 26781
       
                                 'calculate true pressure
       p  := ((UP - B3) * 100000) / B4                    ' p   =  95732
       X1 := (p / 2^8 ) * (p / 256 )                      ' X1  = 139129
       X1a:= (X1 * 3038) / 65535                          ' X1a = 6449
       X2 := (- 7357 * p) / 65535                         ' X2  = -10747
       p  := p + (X1a + X2 + 3791) / 8                    ' p   = 95700
       mmIn := p / 25                                     ' mmIn Baro pressure * 100
       mmInW := mmIn/100                                  ' whole inches   
       mmInF := mmIn - mmInW*100                          ' fractions of inches
       mmHg := p / 100                                    ' mmHg Baro pressure ~600 in Mountainair,NM

       altitudeF:= (1000*mmhg*mmhg) / 42017 - (72346*mmhg) / 1000 + 41214
       altitudeM := 1000*altitudeF / 3280                 ' Actully 3.280839895
     
PUB GetTemp

Baro.init(28,29)                                        ' scl and sda on pin 28 and pin 29

           UP :=0
           Baro.start_adcTemp                           ' start the adc then
           Baro.readBaro                                ' read data via i2c bus
           UT :=  baro.baro_f6 * 256 + baro.baro_f7      'raw 16 bit pressure data in UP
        
                                'Calibration Data
       F1 := 39535 '((baro.baro_f8 * 256) + baro.baro_f9)        'F1 my module data 
       F2 := 40600 '((baro.baro_fa * 256) + baro.baro_fb)        'F2 my module data
       F3 := 3707  '((baro.baro_fc * 256) + baro.baro_fd)        'F3 my module data
       F4 := 26866 '((baro.baro_fe * 256) + baro.baro_ff)        'F4 my module data

       AC1 := 6767        ' calculated values from my module
       AC2 := 634
       AC3 := 152
       AC4 := 3707
       AC5 := 4
       AC6 := 2290
      
       B1 := ((AC3 - 1984) * (-17268)) / 2048 - 8970
       B2 := ((AC2 - 457) * B1 / 8) / (AC3 - 1984)



      X1 := UT  - (AC6 + 1415) * 8                          'X1 =  4310
      X2 := X1 * X1 / 8192                                  'X2 =  2267
      Y2 := -4955 * X2 / 8192                               'Y2 = -1372
      X3 := X2 * X1 / 65536                                 'X3 =  149
      Y3 := 11611 * X3 / 4096                               'Y3 =  422
      X4 := X2 * X2 / 65536                                 'X4 =  78
      Y4 := -12166 * X4 / 16384                             'Y4 =  -58
      B5 := (AC5 + 4096)* (2 * X1 + Y2 + Y3 + Y4)/ 1024     'B5 =  4237
      T  := (B5 + 8) / 8                                    'T =   265  T is degrees C times 10

      TempC := T / 100
      TempF := TempC *  (9 / 5) + 32   
     
                                        
PUB Get6DOF                            ' primary entry point

read6DOF                               ' Put the data in a buffer from 6DOF

  RunningCount := buffer[ 1]<<8 + buffer[ 2]  'Put buffer data into variables
  ax := buffer[ 3]<<8 + buffer[ 4]
  ay := buffer[ 5]<<8 + buffer[ 6]
  az := buffer[ 7]<<8 + buffer[ 8]
  gx := buffer[ 9]<<8 + buffer[ 10]
  gy := buffer[ 11]<<8 + buffer[ 12]
  gz := buffer[ 13]<<8 + buffer[ 14]
return

PUB read6DOF

 repeat while Rxdof <>= "A"                  ' wait for the "A" to insure we are starting with
    Rxdof := uartdof.rxcheck                ' a complete 6dof sentence
        cptr := 0                        ' zero the buffer pointer to start

    repeat while Rxdof <>= "Z" and cptr < 16 ' continue to collect data until the end of sentence ("Z")
      
           Rxdof := uartdof.rx       ' get character from uart Rx
                  buffer[cptr++] := Rxdof   ' save the character in the buff
        buffer[cptr] :=0                 ' make sure the buffer ends with a 0

    return                               ' return to calling routine
        